//
// Created by nicol on 2018-03-18.
//

#ifndef ESC_THREAD_H
#define ESC_THREAD_H

#ifdef _WIN32
#include <windows.h>
struct st_thread {
    DWORD   id;
    HANDLE  handle;
};
typedef struct st_thread* thread_t;
typedef LPTHREAD_START_ROUTINE thread_start_t;
typedef LPVOID thread_arg_t;
#endif
typedef void* (*thread_start_t)(void*);
typedef void* thread_arg_t;
typedef struct st_thread* thread_t;

thread_t thread_create(thread_start_t thread_start, thread_arg_t thread_arg);
int thread_start(thread_t thread);
int thread_wait(thread_t thread);
int thread_destroy(thread_t thread);
int thread_error(thread_t thread);
void* thread_result(thread_t thread);

#endif //ESC_THREAD_H
